;McKulz's Ships Weakness Sniffer
; 1 name 2 class 3 target 4 type 5 init 6 armor 7 damage 8 metal 9 crystal 10 eonium 11 arm/cost 12 dam/cost 13 race

alias swsstart {
  hmake -s shipstats 50
  var %c = 1
  var %l = $lines(shipstats.txt)
  while %c <= %l {
    var %line = $read(shipstats.txt,%c)
    ;echo -a %line
    hadd shipstats $gettok($gettok(%line,1,9),1,32) %line
    inc %c
  }
}


on *:start:{
  swsstart
}

on *:exit:{
  hfree -s shipstats
}

alias read_fleet {
  hmake -s fleet 10
  var %c = 1
  var %l = $lines(fleet.txt)
  while %c <= %l {
    var %line = $read(fleet.txt,%c)
    hadd fleet %c %line
    inc %c
  }
  dec %c

  var %afi = 1
  var %aco = 1
  var %afr = 1
  var %ade = 1
  var %acr = 1
  var %abs = 1

  while %c > 0 {
    var %shiptype = $gettok($gettok($hget(fleet,%c),1,9),1,32)
    var %shipnumber = $gettok($hget(fleet,%c),2,9)
    var %shiptarget = $gettok($hget(shipstats,%shiptype),3,9)
    ;echo -a %shiptype %shipnumber %shiptarget

    if %shiptarget = Fighter { var %afi = $calc(%afi + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }
    elseif %shiptarget = Corvette { var %aco = $calc(%aco + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }
    elseif %shiptarget = Frigate { var %afr = $calc(%afr + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }
    elseif %shiptarget = Destroyer { var %ade = $calc(%ade + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }
    elseif %shiptarget = Cruiser { var %acr = $calc(%acr + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }
    elseif %shiptarget = Battleship { var %abs = $calc(%abs + $gettok($hget(shipstats,%shiptype),7,9) * %shipnumber) }

    dec %c
  }

  var %total = $calc(%afi + %aco + %afr + %ade + %acr + %abs)
  echo -a Anti-FI: %afi $round($calc(%afi / %total * 100),0) $+ %
  echo -a Anti-CO: %aco $round($calc(%aco / %total * 100),0) $+ %
  echo -a Anti-FR: %afr $round($calc(%afr / %total * 100),0) $+ %
  echo -a Anti-DE: %ade $round($calc(%ade / %total * 100),0) $+ %
  echo -a Anti-CR: %acr $round($calc(%acr / %total * 100),0) $+ %
  echo -a Anti-BS: %abs $round($calc(%abs / %total * 100),0) $+ %

  hfree -s fleet

}

on &*:INPUT:*:if /* !iswm $1 { msg $active $maria($1-) | haltdef }

alias maria {
  if $left($1,1) isalnum && $right($1-,1) isalnum { return $replace($1-,$1,$upper($left($1,1)) $+ $right($1,$calc($len($1) - 1)))) $+ . }
  elseif $left($1,1) isalnum && $right($1-,1) !isalnum { return $replace($1-,$1,$upper($left($1,1)) $+ $right($1,$calc($len($1) - 1)))) }
  else return $1-
}
